#ifndef MODULES_DPC_UTILS_INCLUDE_PROXYWRAPPERHELPER_H_
#define MODULES_DPC_UTILS_INCLUDE_PROXYWRAPPERHELPER_H_

#include "SubWrapper.h"

#define GENERATE_SUB_WRAPPER(NAME, DATA_WRAPPER, PROXY_NAME, DATA_TYPE, EVENT_NAME, SERVICE_INS_ID, MAX_SAMPLE_CNT)	\
using Proxy = huawei::ap::sample::proxy::PROXY_NAME; \
using PEvent_##NAME = ara::com::internal::proxy::event::EventAdapter<::DATA_TYPE>;	\
class NAME : public SubWrapper<Proxy, PEvent_##NAME, DATA_TYPE>	\
{	\
public:	\
	DATA_WRAPPER<DATA_TYPE> s;	\
	NAME(const std::string& name, ara::log::Logger& log, std::string serviceInstanceId  = SERVICE_INS_ID, uint32_t maxSampleCount = MAX_SAMPLE_CNT) :	\
		SubWrapper(s, name, log, serviceInstanceId, maxSampleCount)	\
{}	\
private:	\
	PEvent_##NAME& GetEvent() override	\
	{	return _proxy->EVENT_NAME;	} \
};

#endif /* MODULES_DPC_UTILS_INCLUDE_PROXYWRAPPERHELPER_H_ */
